/**
 * P4P Vuze Plugin
 * 
 * Copyright 2008, Yale Laboratory of Networked Systems
 */

package net.yale.cs.p4p.p2p.azureus.client.hacks;

import java.lang.reflect.Method;

public class PeerClassifierHack
{

	/* Class: PeerClassifier
	 * - Provides access to isAzureusIP
	 */
	private static Class CLASS_PeerClassifier;
	private static Method METHD_PeerClassifier_isAzureusIP;

	static {
		/*
		 * Initialize some items we need in order to get access
		 * to the PeerClassifier class.  We'll use some of Java's
		 * reflection.
		 */

		try {
			CLASS_PeerClassifier = Class.forName("com.aelitis.azureus.core.peermanager.utils.PeerClassifier");
			METHD_PeerClassifier_isAzureusIP = CLASS_PeerClassifier.getDeclaredMethod("isAzureusIP", new Class[] { String.class });
		} catch (Exception e) {
			throw new RuntimeException("Failed to locate required data through reflection", e);
		}
	}

	public static boolean isAzureusIP(String ip) {
		try {
			return (Boolean)METHD_PeerClassifier_isAzureusIP.invoke(null, new Object[] {ip} );
		} catch (Exception e) {
			throw new RuntimeException("Failed to execute isAzureusIP method", e);
		}
	}

}
