package net.yale.cs.p4p.p2p.azureus.client.util;

import java.net.InetAddress;
import java.net.UnknownHostException;

public class AddrUtils
{
	public static final int INVALID_ADDRESS = 0xFFFFFFFF;

	public static int addressToInt(InetAddress addr) {
		byte[] addrBytes = addr.getAddress();
		
		/* NOTE: Currently we only handle IPv4 addresses */
		if (addrBytes.length != 4)
			return INVALID_ADDRESS;

		return ((addrBytes[0] & 0x000000FF) << 24)
			| ((addrBytes[1] & 0x000000FF) << 16)
			| ((addrBytes[2] & 0x000000FF) << 8)
			| ((addrBytes[3] & 0x000000FF) << 0);
	}

	public static int addressToInt(String addr) {
		try {
			return addressToInt(InetAddress.getByName(addr));
		} catch (UnknownHostException e) {
			return INVALID_ADDRESS;
		}
	}

}
